///home/berryj/link/bin/genMethods "-g" "-t" "AttributeBase*" "-h" "List" "-I" "LINK/basic/List.h" "-I" "LINK/graph/Attribute.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/List.h>

#include <LINK/graph/Attribute.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef AttributeBase* _AttributeBase_;
typedef List<AttributeBase* > _List_AttributeBase__;
static List<AttributeBase* > s__List_AttributeBase__;

#define _List_AttributeBase__DATA(x) ((List<AttributeBase* >*) (EXTDATA(x)))
#define _List_AttributeBase__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<AttributeBase* > >::type))
#define _List_AttributeBase__ISNT_DATA(x) (!_List_AttributeBase__IS_DATA(x))

#define _List_AttributeBase__CXX_DATA(x) (*(List<AttributeBase* >*) (EXTDATA(VAL(x))))
#define _List_AttributeBase__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<AttributeBase* > >::type))
#define _List_AttributeBase__CXX_ISNT_DATA(x) (!_List_AttributeBase__CXX_IS_DATA(x))


PRIMITIVE STk_init__List_AttributeBase__()
{
	Wrapper<_List_AttributeBase__>::type = STk_new_CXXwrapper_id(
			Wrapper<_List_AttributeBase__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_AttributeBase_>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_AttributeBase_>::markTypedList,
			(void (*)(SCM x))ListWrapper<_AttributeBase_>::freeTypedList);
	Tcl_InitHashTable(&Register<_List_AttributeBase__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_List_AttributeBase__Methods(void);

PRIMITIVE STk_init_methods__List_AttributeBase__()
{
	STk_add_new_cpp_primitive("List-AttributeBase-make", tc_subr_0, 
	(PRIMITIVE (*)(...))  ListWrapper<_AttributeBase_>::makeLinkList);
	STk_add_new_cpp_primitive("List-AttributeBase?", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_AttributeBase_>::linkListP);
	STk_add_new_cpp_primitive("list->List-AttributeBase", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_AttributeBase_>::stkList2LinkList);
	STk_add_new_cpp_primitive("List-AttributeBase->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_AttributeBase_>::linkList2STkList);
	genExtra_List_AttributeBase__Methods();
	return UNDEFINED;
}
